// Actor.h: interface for the CActor class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ACTOR_H__6F9CAF83_519A_419E_87D9_B5346963CAB8__INCLUDED_)
#define AFX_ACTOR_H__6F9CAF83_519A_419E_87D9_B5346963CAB8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <afxtempl.h>

class vtkClipPolyData;
class vtkPlane;
class vtkActor;
class vtkPolyDataMapper;
class vtkRenderer;
class vtkPolyData;
class vtkTexture;
class vtkAlgorithmOutput;

////////////////////////////////////////////////////////////////////////
// class CActor
// vtkActorŬ wrapperŬ̸, clipping Ѵ.
// CActorŬ ĻŬ clipping ϱ,
// m_mapper    
// SetInputForMapper() ϸ  clipping .
////////////////////////////////////////////////////////////////////////

class AFX_EXT_CLASS CActor  
{
protected:
	CActor();
	virtual ~CActor() = 0;	// Abstract class

public:
	virtual void	Initialize();

	virtual void	AddToRenderer(vtkRenderer* ren);
	virtual void	RemoveFromRenderer(vtkRenderer* ren);

	void			SetColor(COLORREF color);
	void			SetColor(double crR, double crG, double crB);
	COLORREF		GetColor();
	
	virtual void	SetVisible(BOOL bVisible);
	BOOL			GetVisible();

	void			SetOpacity(double opacity);
	float			GetOpacity();

	BOOL			IsClipping();
	void			GetClipInfo(double* normal, double* origin);
	virtual void	Clip(BOOL bOn, double* normal = NULL, double* origin = NULL);

	void			SetTexture(vtkTexture* texture);

	void			SetScalarVisibility(BOOL bOn);

	void			SetInputForMapper(vtkAlgorithmOutput* polyDataInput);

	BOOL			IsActorIdentical(vtkActor* actor);

	vtkActor*		GetVtkActor() {return m_actor;}
	
	unsigned long	GetActorMTime();

protected:
	// plain actor
	vtkActor*					m_actor;
	vtkPolyDataMapper*			m_mapper;

	// clip actor
	vtkActor*					m_actorClip;
	vtkPolyDataMapper*			m_mapperClip;

	// clipping stuff
	vtkClipPolyData*			m_clipper;
	vtkPlane*					m_cutPlane;
	BOOL						m_bClip;
	double						m_fClipOrigin[3];
	double						m_fClipNormal[3];

	BOOL						m_bVisible;
	COLORREF					m_color;

	CArray<vtkRenderer*,vtkRenderer*>	m_arrAddedRenderer;		//  CActorü õ  vtkRenderer 

protected:
	// internal vtkRenderer array management
	void	AddVtkActorToAllRenderer(vtkActor* actor);
	void	RemoveVtkActorFromAllRenderer(vtkActor* actor);
	int		FindRendererIndex(vtkRenderer* ren);

};

#endif // !defined(AFX_ACTOR_H__6F9CAF83_519A_419E_87D9_B5346963CAB8__INCLUDED_)
