// ActorCrossLine.cpp: implementation of the CActorCrossLine class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ActorCrossLine.h"

#include "../vtkExt/vtkCrossLineSource.h"

#ifdef _DEBUG

#endif


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CActorCrossLine::CActorCrossLine()
{
	m_source = vtkCrossLineSource::New();
	m_bLaserCord = FALSE;
}

CActorCrossLine::~CActorCrossLine()
{
	m_source->Delete();
}

void CActorCrossLine::Initialize()
{
	CActor::Initialize();

	SetInputForMapper(m_source->GetOutputPort());
}

void CActorCrossLine::SetLineLength(float fLength)
{
	m_source->SetLineLength(fLength);
}

void CActorCrossLine::SetPosition(float* pos)
{
	m_source->SetPosition(pos);
}

void CActorCrossLine::SetShowShape(BOOL* bShowShape)
{
	m_source->SetShowShape(bShowShape);
}


float *	CActorCrossLine::GetPostion() 
{ 
	return m_source->GetPostion() ; 
}	// 
float	CActorCrossLine::GetLength()
{ 
	return m_source->GetLength() ; 
}
BOOL *	CActorCrossLine::GetShowShape() 
{
	return m_source->GetShowShape() ; 
}
BOOL	CActorCrossLine::IsLaserCord()
{
	return m_bLaserCord ;
}
void	CActorCrossLine::SetLaserCord(BOOL bTrue) 
{
	m_bLaserCord = bTrue; 
}
