// vtkCrossLineSource.h: interface for the vtkCrossLineSource class.
//
//////////////////////////////////////////////////////////////////////

#ifndef __VTKCROSSLINESOURCE_H_FIELDLAB__
#define __VTKCROSSLINESOURCE_H_FIELDLAB__

#pragma once

#include "vtkPolyDataAlgorithm.h"

class AFX_EXT_CLASS vtkCrossLineSource : public vtkPolyDataAlgorithm
{
public:
	vtkTypeMacro(vtkCrossLineSource, vtkPolyDataAlgorithm);
	void PrintSelf(ostream& os, vtkIndent indent);

	static vtkCrossLineSource *New();

	void	SetPosition(float* pos);
	void	SetLineLength(float fLength);
	void	SetShowShape(BOOL* bShowShape);		// BOOL[6] ´. ʴ +x,-x,+y,-y,+z,-z
	void	Execute();

	// RequestData/RequestInformation
	int RequestData(vtkInformation*, vtkInformationVector**, vtkInformationVector*) override;
	int RequestInformation(vtkInformation*, vtkInformationVector**, vtkInformationVector*) override;

	float * GetPostion() { return m_pos; }
	float  GetLength() { return m_fLength; }
	BOOL * GetShowShape() { return m_bShowShape ; }
protected:
	vtkCrossLineSource();
	~vtkCrossLineSource();
	vtkCrossLineSource(const vtkCrossLineSource&) = delete;
	void operator=(const vtkCrossLineSource&) = delete;

	float	m_pos[3];
	float	m_fLength;
	BOOL	m_bShowShape[6];

};

#endif

